import java.io.*;

/*
Esercizio 1 di Esercizidel22-5-17
Si consideri la definizione di coppia in Pair.Java, per coppie non modificabili. 
Si chiede di:
 (a) Introdurre in Java, un API per tali coppie;
 (b) Definire un ADT, ImPairADT.java, per tale API;
 (c) Fornire AF e I  di (della rappresentazione data in) PairADT.java;
 (d) Fornire un caso di uso di PairADT.java;
 (e) Provare la correttezza di I.

 public class Pair <A,B> {
   public final A left;
   public final B right;
   public Pair (A x, B y) {
      left = x;
      right = y;
   }
}
 */

/* (a) */
interface ImPairAPI<A,B> {
    //Questo tipo introduce valori astratti coppie della forma (x,y)
    //per un generico tipo A ed  un generico B, rispettivamente.
    public A getLeft();
    public B getRight();
}


/* (b) */
public class ImPairADT <A,B> implements ImPairAPI{
    private final A left;//da nascondere
    private final B right;//da nascondere
    public ImPairADT (A x, B y) {
        left = x;
        right = y;
    }
    public A getLeft(){//da aggiungere per uso effettivo
        return left;
    }
    public B getRight(){//da aggiungere per uso effettivo
        return right;
    }
}

/* (c)
Sia [ImPairADT<Ta,Tb>]={(x,y) | x\inTa, y\inTb, Ta\in[A], Tb\in[B]}, l'insieme dei valo-
ri astratti definiti da ImPairADT<Ta,Tb>. Allora, per ogni valore concreto c esprimibile 
con lo stato concreto definito dai fields della classe:
AF(c) = (c.left,c.right)
I(c) = true
*/

/* (d) */
class main{
    public static void main(String args[]){
        ImPairADT <Integer,String> myPlayCard = new ImPairADT<Integer,String>(3,"fiori");
        System.out.println("il valore della carta e' " + myPlayCard.getLeft());
    }
}

/*
 host-131-114-250-4:OcamlSoluzioni marcob$ cd ZcodeIPA
 host-131-114-250-4:ZcodeIPA marcob$ java main
 il valore della carta e' 3
*/

/* (e)
I(c) e' true quindi e' sempre verificato quindi la correttezza e' banalmente provata
*/

/* (f)
Cosa dire se avessimo richiesto:
 I(c) = c.left!=NULL & c.right!=NULL
 --- vedi esercizio 5 di Esercizidel22-5-17
*/
